/* $Id: script.js 105 2023-05-19 04:00:30Z nishi $ */
const prefix = document.getElementById("swinehub-prefix").value;
const api = location.protocol + "//" + location.host + "/" + prefix + "/v1";
const rss = location.protocol + "//" + location.host + "/" + prefix + "/rss";
const username = document.getElementById("username");
const password = document.getElementById("password");
const repouser = document.getElementById("repouser");
const reponame = document.getElementById("reponame");
const repos = document.getElementById("repositories");
const svn = document.getElementById("svnprefix");
const rlcommit = document.getElementById("repo-latest-commit");
const lcommit = document.getElementById("latest-commit");
const ownername = document.getElementById("ownername");
const path = document.getElementById("path");
const stitle = document.getElementById("swinehub-title");
const version = document.getElementById("swinehub-version").value;
const members = document.getElementById("members");

(function alador() {
	const panel = document.querySelector("#panel");
	let panel_floating = false;
	const floating_threshold = 10;

	function on_scroll() {
		if (!panel_floating && window.scrollY <= floating_threshold) {
			panel.classList.add("floating");
			panel_floating = true;
		} else if (panel_floating && window.scrollY > floating_threshold) {
			panel.classList.remove("floating");
			panel_floating = false;
		}
	}
	on_scroll();
	window.addEventListener("scroll", on_scroll);

	window.addEventListener("load", () => { panel.classList.add("transition") });
})()

function getrepos(){
	if(repos){
		repos.innerHTML = "Connecting to the API ...";
		const xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
			if(this.readyState == 4){
				let result = JSON.parse(this.responseText);
				if(result.code != 0){
					repos.innerHTML = "Failed to fetch. Reason: <code>" + result.error + "</code>";
				}else{
					if(result.error){
						repos.innerHTML = "Failed to fetch. Reason: <code>" + result.error + "</code>";
					}else{
						repos.innerHTML  = "";
						let ab_class = "a";
						for(const repo_name of result.repos){
							const el = document.createElement("a");
							el.classList.add("repo_entry");
							el.classList.add(ab_class);
							if (ab_class === "a") ab_class = "b";
							else ab_class = "a";
							el.href = `${location.protocol}//${location.host}/${prefix}/~${user}/${repo_name}`;
							const user_el = document.createElement("span");
							const slash_el = document.createElement("b");
							const repo_el = document.createElement("span");
							user_el.innerText = `~${user}`;
							slash_el.innerText = "/";
							repo_el.innerText = repo_name;
							el.appendChild(user_el);
							el.appendChild(slash_el);
							el.appendChild(repo_el);
							repos.appendChild(el);
						}
						repos.classList.add("loaded");
						/*for(let i of result.repos){
							repos.innerHTML += "<li><a href=\"" + location.protocol + "//" + location.host + "/" + prefix + "/~" + user + "/" + i + "\">~" + user + "/" + i + "</a></li>\n";
						}*/
					}
				}
			}
		};
		xhr.open("POST", api + "/repos", true);
		xhr.send(user);
	}
}
if(rlcommit){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let splitted = this.responseText.split(/\r?\n/).map(x=>x.replace(/</g, "&lt;").replace(/>/g, "&gt;"));
			let content = splitted.filter((x,i)=>{
				if(i != 0 && i != (splitted.length - 2)) return 1;
				return 0;
			});	
			rlcommit.innerHTML = content.join("\n");
			if (rlcommit.innerHTML.trim().length === 0) {
				const phantom = document.createElement("div");
				phantom.classList.add("phantom");
				phantom.innerText = "(No commits)";
				rlcommit.appendChild(phantom);
			}
		}
	};
	xhr.open("POST", api + "/repo/latest-log", true);
	xhr.send(repouser.value + ":" + reponame.value);
}

if(lcommit){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let splitted = this.responseText.split(/\r?\n/).map(x=>x.replace(/</g, "&lt;").replace(/>/g, "&gt;"));
			let content = splitted.filter((x,i)=>{
				if(i != 0 && i != (splitted.length - 2)) return 1;
				return 0;
			});
			lcommit.innerHTML = content.join("\n");
			if (lcommit.innerHTML.trim().length === 0) {
				const phantom = document.createElement("div");
				phantom.classList.add("phantom");
				phantom.innerText = "(No commits)";
				rlcommit.appendChild(phantom);
			}
		}
	};
	xhr.open("POST", api + "/repo/log", true);
	xhr.send(repouser.value + ":" + reponame.value + ":" + path.value);
}

if(rlcommit || lcommit){
	document.title = stitle.value + " [~" + repouser.value + "/" + reponame.value + "]";
}else if(location.pathname == prefix + "/repos/"){
	document.title = stitle.value + " [Repositories]";
}else if(location.pathname == prefix){
	document.title = stitle.value + " [Home]";
}else if(location.pathname == prefix + "/login/"){
	document.title = stitle.value + " [Login]";
}else if(location.pathname == prefix + "/signup/"){
	document.title = stitle.value + " [Signup]";
}

const ctoken = localStorage.getItem("token");
let user;

function swinehub_create_repo(){
	if(document.getElementById("create-repo").disabled == false){
		const xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
			if(this.readyState == 4){
				let result = JSON.parse(this.responseText);
				if(result.code == 0){
					location = location.protocol + "//" + location.host + "/" + prefix + "/~" + user + "/" + document.getElementById("reponame-input").value;
				}else{
					alert("Error: " + result.error);
				}
			}
		};
		xhr.open("POST", api + "/repo/create", true);
		xhr.send(ctoken + ":" + document.getElementById("reponame-input").value);
	}
}

const valid = new XMLHttpRequest();
valid.onreadystatechange = function(){
	if(this.readyState == 4){
		if(this.status == 200){
			let result = JSON.parse(this.responseText);
			user = result.username;
			document.body.classList.add("logged_in");
			document.getElementById("login_status").innerHTML = "<i>"
			+ (version.endsWith("j")
			? "現在ユーザー「<a href=\"" + prefix + "/~" + user + "\"><code>" + user + "</code></a>」に入っています"
			: "You are logged in as <a href=\"" + prefix + "/~" + user +"\"><code>" + user + "</code></a>") + "</i><button id=\"logout-button\" onclick=\"swinehub_logout()\">" + (version.endsWith("j") ? "ログアウト" : "Logout") + "</button>";
			document.getElementById("repos-button").style.display = "inline";
			try{
				document.getElementById("create-repo").disabled = false;
			}catch{}
			try{
				if(repouser.value == user){
					document.getElementById("delete-button").style.display = "inline";
				}
			}catch{}
			try{
				if(repouser.value == user){
					document.getElementById("set-readme").style.display = "inline";
				}
			}catch{}
			try{
				if(repouser.value == user){
					document.getElementById("delete-user-button").style.display = "inline";
				}
			}catch{}
			getrepos();
		}else{
		}
	}
};
valid.open("POST", api + "/valid", true);
valid.send(ctoken);

function swinehub_login(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				localStorage.setItem("token", result.token);
				location = prefix;
			}
		}
	};
	xhr.open("POST", api + "/login", true);
	xhr.send(username.value + ":" + password.value);
}

function swinehub_signup(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				location = prefix;
			}
		}
	};
	xhr.open("POST", api + "/signup", true);
	xhr.send(username.value + ":" + password.value);
}

function swinehub_create_a_team(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				location = prefix;
			}
		}
	};
	xhr.open("POST", api + "/team/create", true);
	xhr.send(username.value + ":" + password.value + ":" + members.value);
}


function swinehub_delete(){
	if(confirm("Are you sure you want to delete the repository?")){
		const xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
			if(this.readyState == 4){
				let result = JSON.parse(this.responseText);
				if(result.code != 0){
					alert("Error: " + result.error);
				}else{
					location = prefix;
				}
			}
		};
		xhr.open("POST", api + "/repo/delete", true);
		xhr.send(ctoken + ":" + reponame.value);
	}
}

function swinehub_delete_user(){
	if(confirm("Are you sure you want to delete the user?")){
		const xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
			if(this.readyState == 4){
				let result = JSON.parse(this.responseText);
				if(result.code != 0){
					alert("Error: " + result.error);
				}else{
					location = prefix;
				}
			}
		};
		xhr.open("POST", api + "/user/delete", true);
		xhr.send(ctoken);
	}
}



function swinehub_readme(){
	let fr = new FileReader();
	fr.onload = ()=>{
		const xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
			if(this.readyState == 4){
				let result = JSON.parse(this.responseText);
				if(result.code != 0){
					alert("Error: " + result.error);
				}else{
					location.reload();
				}
			}
		};
		xhr.open("POST", api + "/repo/set-readme", true);
		xhr.setRequestHeader("X-Token", ctoken);
		xhr.setRequestHeader("X-Reponame", reponame.value);
		xhr.send(fr.result);
	};
	fr.readAsText(document.getElementById("readme-file").files[0]);
}

function swinehub_logout(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				localStorage.removeItem("token");
				location = prefix;
			}
		}
	};
	xhr.open("POST", api + "/logout", true);
	xhr.send(localStorage.getItem("token"));
}
